       page 55,132
       title prta - direct lpt1 driver
       name prta

;
;       prta - direct lpt1 driver
;
;       R. C. Allen, 5 May 1988
;       R. C. Allen, 7 May 1993 - made it multiport
;
;      for use with msc 5.1 and asm 5.1 LARGE model
;

penter  macro name
        public name
name    proc
        push bp
        mov bp,sp
        push ds
        push es
        push si
        push di
        endm

pleave  macro name
        pop di
        pop si
        pop es
        pop ds
        pop bp
        ret
name    endp
        endm


        .model large

@ab     equ 6
arga equ @ab                 ; arg a
argb    equ     @ab+2           ; arg b
argc    equ     @ab+4           ; arg c
argd    equ     @ab+6           ; arg d
arge    equ     @ab+8           ; arg e

        .code

;
;       void prta(
;       char c,          /* character to output */
;       short port)     /* the printer port # */
;
        penter _prta

	mov al,arga[bp]   	; get the character
	mov dx,argb[bp]   	; get the printer port

        out dx,al               ; send the character
        inc dx                  ; -> status port
oki1:                           ; loop whilst busy
        in al,dx                ; read status
        test al,80h             ; ready?
        jz oki1                 ; no, loop
        inc dx                  ; -> the control port
        mov al,0Dh              ; strobe bit set command
        out dx,al               ; set strobe active
        mov al,0Ch              ; strobe bit reset command
        out dx,al               ; set strobe inactive

        pleave _prta

        end

